﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Runtime.InteropServices;
using TcCNet;

namespace TcCTest
{
    public partial class Form1 : Form
    {
        double LoTc, HiTc, LoCJC, HiCJC;
        UInt32 CallbackCt;

        public static TcC.TScanVCallback MyScanVCallback;

        public Form1()
        {
            InitializeComponent();
        }

        private void StartButton_Click(object sender, EventArgs e)
        {
            LoTc = +10000;
            HiTc = -10000;
            LoCJC = +10000;
            HiCJC = -10000;
            CallbackCt = 0;

            MyScanVCallback = new TcC.TScanVCallback(ScanVCallback);
            UInt32 Status = TcC.TcC_StartAcquisition(1, 0, 0, 1024, 512, 6, MyScanVCallback);
            if ( Status != 0 )
            {
                LogMemo.AppendText("Error " + Status.ToString() + " starting acquisition.\r\n");
                return;
            }
            LogMemo.AppendText("Acquisition started.\r\n");
            DisplayTime.Enabled = true;
        }

        private void StopButton_Click(object sender, EventArgs e)
        {
            DisplayTime.Enabled = false;
            TcLabel.Text = "";
            CJCLabel.Text = "";
            CountLabel.Text = "";
            UInt32 Status = TcC.TcC_StopAcquisition();
            if (Status != 0)
            {
                LogMemo.AppendText("Error " + Status.ToString() + " stopping acquisition.\r\n");
            }
            else
            {
                LogMemo.AppendText("Acquisition stopped.\r\n");
                LogMemo.AppendText("TcC reports " + TcC.TcC_GetCount().ToString() + " calls.\r\n");
            }
        }

        public void ScanVCallback(IntPtr pData, UInt32 DataSize)
        {
            ++CallbackCt;
            double[] ChannelData = new double[DataSize / sizeof(double)];
            Marshal.Copy(pData, ChannelData, 0, ChannelData.Length);
            LoTc = Math.Min(LoTc, ChannelData[0]);
            HiTc = Math.Max(HiTc, ChannelData[0]);
            LoCJC = Math.Min(LoCJC, ChannelData[8]);
            HiCJC = Math.Max(HiCJC, ChannelData[8]);
        }

        private void DisplayTime_Tick(object sender, EventArgs e)
        {
            TcLabel.Text = LoTc.ToString() + ".." + HiTc.ToString();
            CJCLabel.Text = LoCJC.ToString() + ".." + HiCJC.ToString();
            CountLabel.Text = CallbackCt.ToString();
        }
    }
}